﻿using Styx;
using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = _Perdition_s_Reprieve____Arms.Core.Utilities.Log;
using S = _Perdition_s_Reprieve____Arms.Core.Spell;
using SB = _Perdition_s_Reprieve____Arms.Core.Helpers.Spell_Book;
using T = _Perdition_s_Reprieve____Arms.Core.Managers.Talent;
#endregion

namespace _Perdition_s_Reprieve____Arms.Core
{
    class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(Vector3 fromLocation, double Range)
        {
            var Hostile = enemyCount;
            return Hostile != null ? Hostile.Where(x => x.Location.DistanceSquared(fromLocation) <= Range * Range) : null;
        }
        private static List<WoWUnit> enemyCount { get; set; }
        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies())
            {
                if (u == null || !u.IsValid)//<~ Use isUnitValid(u, Range) instead of the frist five of these first calls?
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                enemyCount.Add(u);
            }
        }
        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }
        static Unit() { enemyCount = new List<WoWUnit>(); }
        #endregion

        #region [Method] - Aura Detection
        public static bool auraExists(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in auraExists(); ", xException);
                return false;
            }
        }
        public static uint auraStacks(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in auraStacks(); ", xException);
                return 0;
            }
        }
        public static double auraTimeLeft(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in auraExists(); ", xException);
                return 9999;
            }
        }
        #endregion

        #region [Method] - Cache
        public static bool canExecute;
        public static uint focusedRage;
        public static bool battleCry;
        public static bool battleCryDeadlyCalm;
        public static bool Cleave;
        public static bool colossusSmash;
        public static double Rage;
        public static bool shatteredDefenses;
        public static double targetHealth;

        public static void Cache()
        {
            canExecute = targetHealth < 20;
            focusedRage = auraStacks(Me, SB.auraFocusedRage, true);
            battleCry = auraExists(Me, SB.auraBattleCry);
            battleCryDeadlyCalm = T.deadlyCalm == 0 && auraExists(Me, SB.auraBattleCry);
            Cleave = auraExists(Me, SB.auraCleave);
            colossusSmash = auraExists(currentTarget, SB.auraColossusSmash);
            Rage = luaGetPower();
            shatteredDefenses = auraExists(Me, SB.auraShatteredDefenses);
            targetHealth = currentTarget.HealthPercent;
        }
        #endregion

        #region [Method] - Unit Evaluation
        private static float calculateMeleeRange(WoWUnit Unit) { return !Me.GotTarget ? 0f : Math.Max(5f, Me.CombatReach + 1.3333334f + Unit.CombatReach); }
        public static bool isInMeleeRange(WoWUnit Unit) { return Unit.Distance < calculateMeleeRange(Unit); }
        public static bool isUnitValid(WoWUnit Unit) { return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && isInMeleeRange(Unit); } //<~ Can we skim this down a bit or remove it completely?
        public static double luaGetPower()
        {
            try
            {
                using (StyxWoW.Memory.AcquireFrame()) { return Lua.GetReturnVal<int>("return UnitPower(\"player\");", 0); }
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in playerPower(); ", xException);
                return Me.CurrentPower;
            }
        }
        #endregion
    }
}
